> For the complete documentation index, see [llms.txt](https://docs.cmsfullform.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.cmsfullform.com/documents/commands/block-command.md).

# Block Command

The provided code is part of the `BlockCommand` class within the `System\Commands` namespace. This class has a method `create` that is responsible for creating a new block file and a default view file for that block.

## `create()`

```php
public function create($blockName)
    {
        // Define the path for the new model
        $blockName = ucfirst($blockName);
        $blockPath = ROOT_PATH . '/application/Blocks/' . ucfirst($blockName) . '/' . ucfirst($blockName) . 'Block.php';
        $blockViewsPath = ROOT_PATH . '/application/Blocks/' . ucfirst($blockName) . '/Views/index.php';

        // Check if the model already exists
        if (file_exists($blockPath)) {
            echo "Block {$blockName} already exists.\n";
            return;
        }

        // Define the contents of the block controller
        $blockContent = // Block File Structure

        // Create the block control file
        $blockDir = dirname($blockPath);
        if (!is_dir($blockDir) && !mkdir($viewsDir11, 0777, true) && !is_dir($blockDir)) {
            echo "Can not create {$blockName} folder.\n";
            return;
        }
        file_put_contents($blockPath, $blockContent);

        // create block default view
        $viewsDir = dirname($blockViewsPath);
        if (!is_dir($viewsDir) && !mkdir($viewsDir, 0777, true) && !is_dir($viewsDir)) {
            echo "Can not create Views folder.\n";
            return;
        }
        file_put_contents($blockViewsPath, '');


        echo "Block {$blockName}Block has been created successfully.\n";
    }
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.cmsfullform.com/documents/commands/block-command.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
